#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>

#define MAXSTRFILE 200

void EcrireEnTete(char *filename, unsigned int filenameLength, unsigned int *longueurFichier, unsigned *typeFichier, unsigned int *modeFichier, FILE *inf, FILE *outf)
{
	unsigned char checksum;
	unsigned int i, posTemp;
	unsigned char carLu, vieuxTypeFichier;
	char fileTitle[9];
	char *debutNomFichier;

	/* En-tte: type de bloc = 0 pour en-tte; longueur du bloc = 15 */
	fprintf(outf, "UU<%c%c", 0, 15);

	/* Filtrage du nom du fichier */
	debutNomFichier = strrchr(filename, '\\') + 1;
	if (debutNomFichier == NULL || (unsigned long)debutNomFichier - (unsigned long)filename >= filenameLength)
		debutNomFichier = filename;
	/* Remplissage d'espaces et copie du nom du fichier */
	strcpy(fileTitle, "        ");
	for (i = 0; i < 8 && debutNomFichier[i] != '.'; i++)
		fileTitle[i] = toupper(debutNomFichier[i]);
	/* Checksum */
	checksum = 15;
	for (i = 0; i < 8; i++)
		checksum += fileTitle[i];
	/* criture du nom du fichier */
	fwrite(fileTitle, sizeof(char), strlen(fileTitle), outf);

	/* Type de fichier */
	/* Premier caractre lu */
	fread(&carLu, sizeof(unsigned char), 1, inf);
	printf("CoCo file type: ");
	switch (carLu) {
	case 0 :
		printf("Machine language\n");
		vieuxTypeFichier = *typeFichier = 2;
		break;
	case 255 :
		printf("BASIC\n");
		vieuxTypeFichier = *typeFichier = 0;
		break;
	default :
		printf("Unknown (might be an ASCII BASIC program or a data file)\n");
		/* typeFichier = entier non sign, donc >= 0 */
		vieuxTypeFichier = *typeFichier = 5;
		while (*typeFichier > 2) {
			printf("File type (0 = BASIC, 1 = Data, 2 = ML): ");
			scanf("%u", typeFichier);
		}
	}
	fprintf(outf, "%c", *typeFichier);
	checksum += *typeFichier;
	/* Mode du fichier */
	if (vieuxTypeFichier == *typeFichier) {
		printf("The file type was automatically determined to be: ");
		switch (*typeFichier) {
		case 0 : printf("BASIC"); break;
		case 2 : printf("ML"); break;
		}
		printf(". The file mode is thus likely to be binary.\n");
		*modeFichier = 0;
	} else {
		printf("You manually determined the file type to be: ");
		switch (*typeFichier) {
		case 0 : printf("BASIC"); break;
		case 1 : printf("Data"); break;
		case 2 : printf("ML"); break;
		}
		printf(". The file mode is thus likely to be ASCII.\n");
		*modeFichier = 255;
	}
	/* *modeFichier = 5; */ /* Use the automatic mode by default BWH */
	while ((*modeFichier) != 0 && (*modeFichier) != 255) {
		printf("File mode (0 = binary, 255 = ASCII): ");
		scanf("%u", modeFichier);
	}
	fprintf(outf, "%c", *modeFichier);
	checksum += (*modeFichier);
	/* Gap flag: 0 = continuous flow (binaire), 255 = gaps (ASCII)
	Le gap flag est, par dfaut, gal au mode du fichier */
	fprintf(outf, "%c", *modeFichier);
	checksum += (*modeFichier);

	/* Longueur du fichier */
	if (*modeFichier == 0) {
		/* 2e caractre lu */
		fread(&carLu, sizeof(char), 1, inf);
		*longueurFichier = (unsigned)carLu * 256;
		/* 3e caractre lu */
		fread(&carLu, sizeof(char), 1, inf);
		(*longueurFichier) += (unsigned)carLu;
	} else
		*longueurFichier = 0;

	/* Adresse d'excution */
	if (*typeFichier == 2) {
		posTemp = ftell(inf);
		if (fseek(inf, -2, SEEK_END)) {
			fclose(inf);
			fclose(outf);
			printf("Error: invalid file length\n");
			exit(1);
		}
		printf ("exec addr =");
		for (i = 0; i < 2; i++) {
			/* Lire l'adresse d'excution */
			fread(&carLu, sizeof(unsigned char), 1, inf);
			fprintf(outf, "%c", carLu);
			printf ("%2x", carLu);
			checksum += carLu;
		}
		printf ("\n");
		fseek(inf, posTemp, SEEK_SET);
	} else
		fprintf(outf, "%c%c", 0, 0);

	/* Adresse de dpart */
	if (*typeFichier == 2)
		for (i = 0; i < 2; i++) {
			/* 4e et 5e caractres lus (si ML) */
			fread(&carLu, sizeof(char), 1, inf);
			fprintf(outf, "%c", carLu);
			checksum += carLu;
		}
	else
		fprintf(outf, "%c%c", 0, 0);

	fprintf(outf, "%c", checksum);
}

char TransfererBloc(unsigned long longueurFichier, unsigned long *nbCarLus, unsigned int typeFichier, unsigned int modeFichier, FILE *inf, FILE *outf)
{
	unsigned char buffer[255], bufTemp[255];
	unsigned char checksum, longueurBloc, longueurTemp;
	unsigned int i;
	unsigned long posFichier;
	char reponse;
	static char writeRemainder = -1;

	/* Lire <= 255 caractres */
	longueurBloc = fread(buffer, sizeof(unsigned char), 255, inf);
	if (longueurBloc == 255 && modeFichier == 0) {
		posFichier = ftell(inf);
		longueurTemp = fread(bufTemp, sizeof(unsigned char), 255, inf);
		fseek(inf, posFichier, SEEK_SET);
	} else
		longueurTemp = 0;
	/* La longueur prvue est-elle dpasse? Si oui, crit-on le reste?*/
	if (writeRemainder < 0 &&
		((modeFichier != 0 && *nbCarLus + longueurBloc > longueurFichier) ||
		(typeFichier == 2 && modeFichier == 0 &&
			longueurTemp < 5 && *nbCarLus + longueurBloc + longueurTemp - 5 > longueurFichier) ||
		(typeFichier == 0 && modeFichier == 0 &&
			longueurTemp < 2 && *nbCarLus + longueurBloc + longueurTemp - 2 > longueurFichier))) {
		printf("The file appears to be longer than expected. Should I write the remainder (y/n)? ");
#ifdef WIN32
		reponse = toupper(_getche());
#else
		reponse = toupper(getchar());
#endif
		writeRemainder = (reponse == 'Y');
	}

	/* Si la longueur est dpasse et le reste ne doit pas tre crit, se limiter  la taille prvue du fichier. */
	if (writeRemainder == 0) {
		longueurBloc = (unsigned char)(longueurFichier - *nbCarLus);
		if (typeFichier == 2 && modeFichier == 0)
			longueurBloc += 5;
	}

	if (typeFichier == 2 && modeFichier == 0 && longueurTemp < 5) /* On a 255 + [0-4] caractres */
		longueurBloc -= (5 - longueurTemp);

	/* Fichier trop court */
	if (longueurBloc < 255 && *nbCarLus + longueurBloc < longueurFichier) {
		printf("The file appears to be shorter than expected. I will make this block terminate properly, but you might encounter an IO error when you use it with a CoCo or an emulator.\n");
		writeRemainder = 0;
	}

	/* S'il ne reste rien  crire, sortir immdiatement. */
	if (longueurBloc == 0)
		return writeRemainder;

	/* En-tte (block byte = 1) */
	fprintf(outf, "UU<%c%c", 1, longueurBloc);
	checksum = 0;
	/* Transfert du bloc */
	for (i = 0; i < longueurBloc; i++) {
		fprintf(outf, "%c", buffer[i]);
		checksum += buffer[i];
	}
	checksum += longueurBloc + 1;
	/* criture du checksum */
	fprintf(outf, "%c", checksum);

	(*nbCarLus) += longueurBloc;
	return writeRemainder;
}

int main(int argc, char **argv) {
	FILE *infile, *outfile;
	char strinfile[MAXSTRFILE + 1], stroutfile[MAXSTRFILE + 1];
	unsigned int i;
	unsigned int longueurFichier, typeFichier, modeFichier;
	unsigned long nbCarLus;
	char ecritureBloc;
#ifdef WIN32
	struct _stat statFile;
#else
	struct stat statFile;
#endif

	printf("DiskTape disk-to-tape CoCo file transfer utility\n");
	printf("Version 1.1\n");
#ifdef WIN32
	printf("Copyright 1998 by Jean-Franois Morin\n\n");
#else
	printf("Copyright 1998 by Jean-Franois Morin\n\n");
#endif

	if (argc < 2) {
		printf("Disk (input) file: ");
		fgets (strinfile, MAXSTRFILE, stdin);
		/* Remove the trailing newline */
		strinfile [strlen(strinfile) - 1] = '\0';
	} else {
		strncpy(strinfile, argv[1], MAXSTRFILE);
		printf("Disk (input) file: %s\n", strinfile);
	}
	if (argc < 3) {
		printf("Cassette (output) file: ");
		fgets (stroutfile, MAXSTRFILE, stdin);
		/* Remove the trailing newline */
		stroutfile [strlen(stroutfile) - 1] = '\0';
	} else {
		strncpy(stroutfile, argv[2], MAXSTRFILE);
		printf("Cassette (output) file: %s\n", stroutfile);
	}

	if ((infile = fopen(strinfile, "rb")) == NULL) {
		perror("Error opening input file");
		exit(1);
	}
	if ((outfile = fopen(stroutfile, "wb")) == NULL) {
		fclose(infile);
		perror("Error opening output file");
		exit(1);
	}

	/* criture du leader de 128 caractres $FF */
	for (i = 0; i < 128; i++)
		fprintf(outfile, "U");

	EcrireEnTete(stroutfile, strlen(stroutfile), &longueurFichier, &typeFichier, &modeFichier, infile, outfile);

	/* Sparateur obligatoire */
	for (i = 0; i < 128; i++)
		fprintf(outfile, "U");

	if (longueurFichier == 0) {
		fseek(infile, 0, SEEK_SET);
#ifdef WIN32
		_stat(strinfile, &statFile);
#else
		stat(strinfile, &statFile);
#endif
		longueurFichier = statFile.st_size;
	}

	nbCarLus = 0;
	ecritureBloc = -1;
	while (!ferror(infile) && !feof(infile) && ecritureBloc) {
		ecritureBloc = TransfererBloc(longueurFichier, &nbCarLus, typeFichier, modeFichier, infile, outfile);
		if (modeFichier == 255)
			for (i = 0; i < 128; i++)
				fprintf(outfile, "U");
	}

	fclose(infile);

	fprintf(outfile, "UU<%c%c%c", 255, 0, 255);
	fclose(outfile);
	
	exit (0);
}
